// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.
define([
  "cloudera/Util",
  "cloudera/chart/TimeControlledContent",
  "cloudera/chart/TimeRange",
  "cloudera/common/I18nDataTable"
], function(Util, TimeControlledContent, TimeRange, I18nDataTable) {

/**
 * JavaScript for the main Landing Page Status Table.
 */
return function(options) {

/*
  var options = {
    showCommands: true|false,
    timestamp: timestamp,
    currentMode: currentMode,
    clusterId: clusterId,
    tableSelector: "#tableId",
    containerSelector: "#containerId",
    ajaxURL: "..."
  };
*/

  var MENU_ITEM_HEIGHT = 26;
  var DIVIDER_ITEM_HEIGHT = 20;

  var updateDropdownOrientation = function() {
    var $table = $(options.tableSelector);
    var maxHeight = $(document).height();
    $.each($table.find(".serviceCommands"), function(i, elem) {
      var $elem = $(elem);
      var $menuEntries = $elem.find(".dropdown-menu li");
      var $dividers = $elem.find(".dropdown-menu li.divider");
      var menuHeight = ($menuEntries.length - $dividers.length) * MENU_ITEM_HEIGHT
        + $dividers.length * DIVIDER_ITEM_HEIGHT;
      if ($elem.offset().top + $elem.height() + menuHeight > maxHeight) {
        $elem.addClass("dropup");
      } else {
        $elem.removeClass("dropup");
      }
    });
  };

  var beforeUpdate = function($filteredResponse) {
    var $resultContainer = $("<div>").html($filteredResponse);
    var $container = $(options.containerSelector);
    if ($container.find(".statusBody").hasClass("hidden")) {
      $(".statusBody", $resultContainer).addClass("hidden");
      $(".toggleIcon", $resultContainer)
        .removeClass("icon-chevron-down")
        .addClass("icon-chevron-right");
    }
    return $resultContainer.html();
  };

  var afterUpdate = function() {
    updateDropdownOrientation();
  };

  $(window).resize(Util.throttle(updateDropdownOrientation, 500));

  $(options.containerSelector).on("click", ".statusHeader", function(e) {
    var $statusHeader = $(this);
    var $tgt = $(e.target);

    if ($tgt.hasClass("clusterDropdown") || $tgt.parents(".clusterDropdown").length > 0) {
      return;
    }

    var $statusBody = $statusHeader.siblings(".statusBody");
    var $toggleIcon = $statusHeader.find(".toggleIcon");
    $toggleIcon
      .removeClass("icon-chevron-right")
      .removeClass("icon-chevron-down");

    if ($statusBody.hasClass("hidden")) {
      $statusBody.removeClass("hidden");
      $toggleIcon.addClass("icon-chevron-down");
    } else {
      $statusBody.addClass("hidden");
      $toggleIcon.addClass("icon-chevron-right");
    }

    $.publish("statusCollapseStateChanged");
  });

  var opts = {
    urlParams: {
      timestamp: options.timestamp,
      clusterId: options.clusterId,
      currentMode: options.currentMode
    },
    isCurrentMode: options.currentMode,
    beforeUpdate: beforeUpdate,
    afterUpdate: afterUpdate,
    updateOnPageLoad: true,
    url: options.ajaxURL,
    containerSelector: options.containerSelector
  };
  var timeControlledContent = new TimeControlledContent(opts);
};

});
